<div [ngClass]="getStyle()">
  <table class="table table-bordered table-sm">
    <thead>
      <tr>
        <th *ngIf="lineNumber && (fields?.isNotEmpty ?? false)">#</th>
        <th *ngFor="let field of fields">{{field}}</th>
      </tr>
    </thead>
    <tbody>
      <tr
        *ngFor="let row of rows; let i=index "
        [class.hover]="hoveringRow(i)"
        [class.selected]="selectedRow(i)"
      >
        <td
          class="line-number"
          *ngIf="lineNumber"
          (mouseover)="overCell(i, -1)"
          (mouseout)="outCell(i, -1)"
          (click)="clickCell(i, -1, $event)"
        >
          {{rowIndex(i)}}
        </td>
        <td
          *ngFor="let cell of row; let j=index"
          [class.hover]="hoveringColumn(j) || hoveringCell(i, j)"
          [class.selected]="selectedColumn(j) || selectedCell(i, j)"
          (mouseover)="overCell(i, j)"
          (mouseout)="outCell(i,j)"
          (click)="clickCell(i, j, $event)"
        >
          <div *ngIf="enabledQuickEdit(j)" popupSource>
            {{cell}}
            <material-button
              icon
              clear-size
              (trigger)="startQuickEdit(i, j, $event)"
            >
              <material-icon icon="edit" size="small"></material-icon>
            </material-button>
          </div>
          <div *ngIf="enabledQuickEdit(j) == false">
            {{cell}}
          </div>
        </td>
      </tr>
    </tbody>
  </table>
</div>

<material-popup
  autoDismiss
  matchMinSourceWidth
  [source]="quickEditPopupSource"
  [(visible)]="quickEditPopupVisible"
  [enforceSpaceConstraints]="true"
>
  <div class="popup-content">
    <material-input
      autoFocus
      multiline
      type="text"
      (keydown.enter)="saveQuickEdit($event)"
      [(ngModel)]="quickEditValue"
    >
    </material-input>
    <material-button
      dense
      raised
      class="blue"
      (trigger)="saveQuickEdit($event)"
    >
      Save
    </material-button>
  </div>
</material-popup>
